#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include <unistd.h>

#include <autonosim.h>



int NTasks;
int MyTaskId;



int FUNCTION_A;
int FUNCTION_B[2];
double FUNCTION_C;
double FUNCTION_D[3];

void FUNCTION_Arguments (void)
{
  AutoNOSim_Integer (&FUNCTION_A);
  AutoNOSim_Integers (FUNCTION_B, 2);
  AutoNOSim_Real (&FUNCTION_C);
  AutoNOSim_Reals (FUNCTION_D, 3);
}

int FUNCTION_E;
double FUNCTION_F;
char FUNCTION_G[80];

void FUNCTION_ReturnValues (void)
{
  AutoNOSim_Integer (&FUNCTION_E);
  AutoNOSim_Real (&FUNCTION_F);
  AutoNOSim_String (FUNCTION_G, 80);
}

void FUNCTION_Body (void)
{
  fprintf (stderr, 
	   " <taskId %d> calculate \n", 
	   MyTaskId);

  sleep (5);
  FUNCTION_E = FUNCTION_A + MyTaskId;
  FUNCTION_F = FUNCTION_C * MyTaskId;
  sprintf (FUNCTION_G, "taskId=%d", MyTaskId);
}



int main (int argc, char *argv[]) 
{
  int iTask;

  AutoNOSim_Initialize (&argc, &argv);

  NTasks = AutoNOSim_NTasks ();
  MyTaskId = AutoNOSim_MyTaskId ();
  fprintf (stderr, 
	   " <taskId %d> num. tasks %d \n", 
	   MyTaskId, NTasks);
  


  if (MyTaskId == AUTONOSIM_MASTER_TASK_ID) {
    FUNCTION_A = 1;
    FUNCTION_B[0] = 10;
    FUNCTION_B[1] = 100;
    FUNCTION_C = 3.0;
    FUNCTION_D[0] = 0.1;
    FUNCTION_D[1] = 0.2;
    FUNCTION_D[2] = 0.3;

    AutoNOSim_Clear (AUTONOSIM_PACKING);
    FUNCTION_Arguments ();
    for (iTask = 0; iTask < NTasks; iTask++) {
      AutoNOSim_SendTo (iTask);
    }
  }

  AutoNOSim_ReceiveFrom (AUTONOSIM_MASTER_TASK_ID);
  AutoNOSim_Clear (AUTONOSIM_UNPACKING);
  FUNCTION_Arguments ();

  fprintf (stderr, 
	   " <taskId %d> A %d B %d %d \n",
	   MyTaskId, FUNCTION_A, FUNCTION_B[0], FUNCTION_B[1]);
  fprintf (stderr, 
	   " <taskId %d> C %f D %f %f %f \n",
	   MyTaskId, 
	   FUNCTION_C, FUNCTION_D[0], FUNCTION_D[1], FUNCTION_D[2]);

  FUNCTION_Body ();

  AutoNOSim_Clear (AUTONOSIM_PACKING);
  FUNCTION_ReturnValues ();
  AutoNOSim_SendTo (AUTONOSIM_MASTER_TASK_ID);

  if (MyTaskId == AUTONOSIM_MASTER_TASK_ID) {
    for (iTask = 0; iTask < NTasks; iTask++) {
      AutoNOSim_ReceiveFrom (iTask);
      AutoNOSim_Clear (AUTONOSIM_UNPACKING);
      FUNCTION_ReturnValues ();
      
      fprintf (stderr, 
	       " <master> from taskId %d E %d F %f G %s \n",
	       iTask, 
	       FUNCTION_E, FUNCTION_F, FUNCTION_G);
    }
  }



  AutoNOSim_Terminate ();

  return 0;
}








