#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include <unistd.h>

#include <autonosim.h>



/* if the exchange file "../data/case_6x6_d6/ex_6x6" is used, */
/* the number of domains (processes) is 6.  */

/* if the exchange file "../data/case_10x10_d4/ex_10x10" is used, */
/* the number of domains (processes) is 4.  */



int NTasks;
int MyTaskId;

#define MAX_NODES 100000

double Scalars[MAX_NODES];
double Vector2Ds[MAX_NODES][2];
double Vector3Ds[MAX_NODES][3];

double v0[MAX_NODES * 3];
double v1[MAX_NODES * 3];

int main (int argc, char *argv[]) 
{
  char *exchangeFileName;
  double sp;

  AutoNOSim_Initialize (&argc, &argv);

  if (argc < 2) {
    fprintf (stderr, 
	     " usage : mpirun -np ??? sample2 exchange_file \n");
    exit (1);
  }

  NTasks = AutoNOSim_NTasks ();
  MyTaskId = AutoNOSim_MyTaskId ();
  fprintf (stderr, 
	   " <taskId %d> num. tasks %d \n", 
	   MyTaskId, NTasks);
  
  exchangeFileName = argv[1];
  AutoNOSim_ReadExchangeFile (exchangeFileName);
  
  fprintf (stderr, 
	   " <taskId %d> calculate step 1 \n", 
	   MyTaskId);
  sleep (5);

  AutoNOSim_Exchange (AUTONOSIM_OP_SUM, 1, Scalars);

  fprintf (stderr, 
	   " <taskId %d> calculate step 2 \n", 
	   MyTaskId);
  sleep (5);

  AutoNOSim_Exchange (AUTONOSIM_OP_MAX, 2, (double*)Vector2Ds);

  fprintf (stderr, 
	   " <taskId %d> calculate step 3 \n", 
	   MyTaskId);
  sleep (5);

  AutoNOSim_Exchange (AUTONOSIM_OP_MIN, 3, (double*)Vector3Ds);

  sp = AutoNOSim_ScalarProduct (3, v0, v1);
  fprintf (stderr, 
	   " <taskId %d> scalar-prodct %f \n", 
	   MyTaskId, sp);

  AutoNOSim_Terminate ();

  return 0;
}
